HTTP::Cookies - Crystal 1.20.2

# class HTTP::Cookies

- HTTP::Cookies
- Reference
- Object

##
Overview

Represents a collection of cookies as it can be present inside a HTTP request or response.

NOTE To use `Cookies`, you must explicitly import it with `require "http/cookie"`

##
Included Modules

- Enumerable(HTTP::Cookie)

##
Defined in:

http/cookies.cr

##
Constructors

- .from_client_headers(headers : HTTP::Headers) : self

  Creates a new instance by parsing the `Cookie` headers in the given `HTTP::Headers`.

- .from_headers(headers) : self

  Creates a new instance by parsing the `Cookie` and `Set-Cookie` headers in the given `HTTP::Headers`.

  DEPRECATED Use `.from_client_headers` or `.from_server_headers` instead.

- .from_server_headers(headers : HTTP::Headers) : self

  Creates a new instance by parsing the `Set-Cookie` headers in the given `HTTP::Headers`.

- .new

  Creates a new empty instance.

##
Instance Method Summary

- #<<(cookie : Cookie) : Cookie

  Adds the given cookie to this collection, overrides an existing cookie with the same name if present.

- #==(other : self)

  Returns `true` if this reference is the same as other.

- #[](key : String) : Cookie

  Gets the current `HTTP::Cookie` for the given key.

- #[]=(key : String, value : String) : Cookie

  Sets a new cookie in the collection with a string value.

- #[]=(key : String, value : Cookie) : Cookie

  Sets a new cookie in the collection to the given `HTTP::Cookie` instance.

- #[]?(key : String) : Cookie | Nil

  Gets the current `HTTP::Cookie` for the given key or `nil` if none is set.

- #add_request_headers(headers : HTTP::Headers) : HTTP::Headers

  Adds `Cookie` headers for the cookies in this collection to the given `HTTP::Headers` instance and returns it.

- #add_response_headers(headers : HTTP::Headers) : HTTP::Headers

  Adds `Set-Cookie` headers for the cookies in this collection to the given `HTTP::Headers` instance and returns it.

- #clear : Hash(String, Cookie)

  Clears the collection, removing all cookies.

- #delete(key : String) : Cookie | Nil

  Deletes and returns the `HTTP::Cookie` for the specified key, or returns `nil` if key cannot be found in the collection.

- #each(& : Cookie -> )

  Yields each `HTTP::Cookie` in the collection.

- #each : Iterator(Cookie)

  Returns an iterator over the cookies of this collection.

- #empty? : Bool

  Whether the collection contains any cookies.

- #fill_from_client_headers(headers : HTTP::Headers) : self

  Filling cookies by parsing the `Cookie` headers in the given `HTTP::Headers`.

- #fill_from_headers(headers)

  Filling cookies by parsing the `Cookie` and `Set-Cookie` headers in the given `HTTP::Headers`.

  DEPRECATED Use `#fill_from_client_headers` or `#fill_from_server_headers` instead.

- #fill_from_server_headers(headers : HTTP::Headers) : self

  Filling cookies by parsing the `Set-Cookie` headers in the given `HTTP::Headers`.

- #has_key?(key : String) : Bool

  Returns `true` if a cookie with the given key exists.

- #hash(hasher)

  See `Object#hash(hasher)`

- #inspect(io : IO)

  Returns a string representation of this cookies list.

- #pretty_print(pp) : Nil

  Returns a string representation of this cookies list.

- #size : Int32

  Returns the number of cookies contained in this collection.

- #to_h : Hash(String, Cookie)

  Returns this collection as a plain `Hash`.

- #to_s(io : IO)

  Returns a string representation of this cookies list.

### Instance methods inherited from module `Enumerable(HTTP::Cookie)`

accumulate(initial : U) : Array(U) forall U
accumulate : Array(T)
accumulate(initial : U, &block : U, T -> U) : Array(U) forall U
accumulate(&block : T, T -> T) : Array(T) accumulate, all?(& : T -> ) : Bool
all?(pattern) : Bool
all? : Bool all?, any?(& : T -> ) : Bool
any?(pattern) : Bool
any? : Bool any?, chunks(&block : T -> U) forall U chunks, compact_map(& : T -> _) compact_map, count(& : T -> ) : Int32
count(item) : Int32 count, cycle(n, & : T -> ) : Nil
cycle(& : T -> ) : Nil cycle, each(& : T -> ) each, each_cons(count : Int, reuse = false, &) each_cons, each_cons_pair(& : T, T -> ) : Nil each_cons_pair, each_slice(count : Int, reuse = false, &) each_slice, each_step(n : Int, *, offset : Int = 0, & : T -> ) : Nil each_step, each_with_index(offset = 0, &) each_with_index, each_with_object(obj : U, & : T, U -> ) : U forall U each_with_object, empty? : Bool empty?, find(if_none = nil, & : T -> ) find, find!(& : T -> ) : T find!, find_value(if_none = nil, & : T -> ) find_value, first(&)
first(count : Int) : Array(T)
first : T first, first? : T | Nil first?, flat_map(& : T -> _) flat_map, group_by(& : T -> U) forall U group_by, in_groups_of(size : Int, filled_up_with : U = nil) forall U
in_groups_of(size : Int, filled_up_with : U = nil, reuse = false, &) forall U in_groups_of, in_slices_of(size : Int) : Array(Array(T)) in_slices_of, includes?(obj) : Bool includes?, index(& : T -> ) : Int32 | Nil
index(obj) : Int32 | Nil index, index!(& : T -> ) : Int32
index!(obj) : Int32 index!, index_by(& : T -> U) : Hash(U, T) forall U index_by, join(io : IO, separator = "") : Nil
join(separator, io : IO) : Nil
join(separator = "") : String
join(io : IO, separator = "", & : T, IO -> )
join(separator, io : IO, &)
join(separator = "", & : T -> ) join, map(& : T -> U) : Array(U) forall U map, map_with_index(offset = 0, & : T, Int32 -> U) : Array(U) forall U map_with_index, max(count : Int) : Array(T)
max : T max, max? : T | Nil max?, max_by(& : T -> U) : T forall U max_by, max_by?(& : T -> U) : T | Nil forall U max_by?, max_of(& : T -> U) : U forall U max_of, max_of?(& : T -> U) : U | Nil forall U max_of?, min(count : Int) : Array(T)
min : T min, min? : T | Nil min?, min_by(& : T -> U) : T forall U min_by, min_by?(& : T -> U) : T | Nil forall U min_by?, min_of(& : T -> U) : U forall U min_of, min_of?(& : T -> U) : U | Nil forall U min_of?, minmax : Tuple(T, T) minmax, minmax? : Tuple(T | Nil, T | Nil) minmax?, minmax_by(& : T -> U) : Tuple(T, T) forall U minmax_by, minmax_by?(& : T -> U) : Tuple(T, T) | Tuple(Nil, Nil) forall U minmax_by?, minmax_of(& : T -> U) : Tuple(U, U) forall U minmax_of, minmax_of?(& : T -> U) : Tuple(U, U) | Tuple(Nil, Nil) forall U minmax_of?, none?(& : T -> ) : Bool
none?(pattern) : Bool
none? : Bool none?, one?(& : T -> ) : Bool
one?(pattern) : Bool
one? : Bool one?, partition(& : T -> ) : Tuple(Array(T), Array(T))
partition(type : U.class) forall U partition, present? : Bool present?, product(initial : Number)
product
product(initial : Number, & : T -> )
product(& : T -> _) product, reduce(memo, &)
reduce(&) reduce, reduce?(&) reduce?, reject(& : T -> )
reject(type : U.class) forall U
reject(pattern) : Array(T) reject, sample(n : Int, random : Random | Nil = nil) : Array(T)
sample(random : Random | Nil = nil) : T sample, select(& : T -> )
select(type : U.class) : Array(U) forall U
select(pattern) : Array(T) select, size : Int32 size, skip(count : Int) skip, skip_while(& : T -> ) : Array(T) skip_while, sum(initial)
sum
sum(initial, & : T -> )
sum(& : T -> ) sum, take_while(& : T -> ) : Array(T) take_while, tally(hash)
tally : Hash(T, Int32) tally, tally_by(hash, &)
tally_by(&block : T -> U) : Hash(U, Int32) forall U tally_by, to_a : Array(T)
to_a(& : T -> U) : Array(U) forall U to_a, to_h
to_h(& : T -> Tuple(K, V)) forall K, V to_h, to_set : Set(T)
to_set(&block : T -> U) : Set(U) forall U to_set, zip(*others : Indexable | Iterable | Iterator, &)
zip(*others : Indexable | Iterable | Iterator) zip, zip?(*others : Indexable | Iterable | Iterator, &)
zip?(*others : Indexable | Iterable | Iterator) zip?

### Class methods inherited from module `Enumerable(HTTP::Cookie)`

element_type(x) element_type

### Instance methods inherited from class `Reference`

==(other : self)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup, hash(hasher) hash, initialize initialize, inspect(io : IO) : Nil inspect, object_id : UInt64 object_id, pretty_print(pp) : Nil pretty_print, same?(other : Reference) : Bool
same?(other : Nil) same?, to_s(io : IO) : Nil to_s

### Constructor methods inherited from class `Reference`

new new, unsafe_construct(address : Pointer, *args, **opts) : self unsafe_construct

### Class methods inherited from class `Reference`

pre_initialize(address : Pointer) pre_initialize

### Instance methods inherited from class `Object`

! : Bool !, !=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, as(type : Class) as, as?(type : Class) as?, class class, dup dup, hash(hasher)
hash hash, in?(collection : Object) : Bool
in?(*values : Object) : Bool in?, inspect(io : IO) : Nil
inspect : String inspect, is_a?(type : Class) : Bool is_a?, itself itself, nil? : Bool nil?, not_nil!(message)
not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, responds_to?(name : Symbol) : Bool responds_to?, tap(&) tap, to_json(io : IO) : Nil
to_json : String to_json, to_pretty_json(indent : String = " ") : String
to_pretty_json(io : IO, indent : String = " ") : Nil to_pretty_json, to_s(io : IO) : Nil
to_s : String to_s, to_yaml(io : IO) : Nil
to_yaml : String to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io : String | IO, root : String)
from_json(string_or_io : String | IO) from_json, from_yaml(string_or_io : String | IO) from_yaml

### Macros inherited from class `Object`

class_getter(*names, &block) class_getter, class_getter!(*names) class_getter!, class_getter?(*names, &block) class_getter?, class_property(*names, &block) class_property, class_property!(*names) class_property!, class_property?(*names, &block) class_property?, class_setter(*names) class_setter, def_clone def_clone, def_equals(*fields) def_equals, def_equals_and_hash(*fields) def_equals_and_hash, def_hash(*fields) def_hash, delegate(*methods, to object) delegate, forward_missing_to(delegate) forward_missing_to, getter(*names, &block) getter, getter!(*names) getter!, getter?(*names, &block) getter?, property(*names, &block) property, property!(*names) property!, property?(*names, &block) property?, setter(*names) setter

##
Constructor Detail

def self.from_client_headers(headers : HTTP::Headers) : self #

Creates a new instance by parsing the `Cookie` headers in the given `HTTP::Headers`.

See `HTTP::Client::Response#cookies`.

def self.from_headers(headers) : self #

Creates a new instance by parsing the `Cookie` and `Set-Cookie` headers in the given `HTTP::Headers`.

See `HTTP::Request#cookies` and `HTTP::Client::Response#cookies`.

DEPRECATED Use `.from_client_headers` or `.from_server_headers` instead.

def self.from_server_headers(headers : HTTP::Headers) : self #

Creates a new instance by parsing the `Set-Cookie` headers in the given `HTTP::Headers`.

See `HTTP::Request#cookies`.

def self.new #

Creates a new empty instance.

##
Instance Method Detail

def <<(cookie : Cookie) : Cookie #

Adds the given cookie to this collection, overrides an existing cookie with the same name if present.

    response.cookies << HTTP::Cookie.new("foo", "bar", http_only: true)

def ==(other : self) #
Description copied from class Reference

Returns `true` if this reference is the same as other. Invokes `same?`.

def [](key : String) : Cookie #

Gets the current `HTTP::Cookie` for the given key.

    request.cookies["foo"].value # => "bar"

def []=(key : String, value : String) : Cookie #

Sets a new cookie in the collection with a string value. This creates a never expiring, insecure, not HTTP-only cookie with no explicit domain restriction and no path.

    require "http/client"

    request = HTTP::Request.new "GET", "/"
    request.cookies["foo"] = "bar"

def []=(key : String, value : Cookie) : Cookie #

Sets a new cookie in the collection to the given `HTTP::Cookie` instance. The name attribute must match the given key, else `ArgumentError` is raised.

    require "http/client"

    response = HTTP::Client::Response.new(200)
    response.cookies["foo"] = HTTP::Cookie.new("foo", "bar", "/admin", Time.utc + 12.hours, secure: true)

def []?(key : String) : Cookie | Nil #

Gets the current `HTTP::Cookie` for the given key or `nil` if none is set.

    require "http/client"

    request = HTTP::Request.new "GET", "/"
    request.cookies["foo"]? # => nil
    request.cookies["foo"] = "bar"
    request.cookies["foo"]?.try &.value # > "bar"

def add_request_headers(headers : HTTP::Headers) : HTTP::Headers #

Adds `Cookie` headers for the cookies in this collection to the given `HTTP::Headers` instance and returns it. Removes any existing `Cookie` headers in it.

def add_response_headers(headers : HTTP::Headers) : HTTP::Headers #

Adds `Set-Cookie` headers for the cookies in this collection to the given `HTTP::Headers` instance and returns it. Removes any existing `Set-Cookie` headers in it.

def clear : Hash(String, Cookie) #

Clears the collection, removing all cookies.

def delete(key : String) : Cookie | Nil #

Deletes and returns the `HTTP::Cookie` for the specified key, or returns `nil` if key cannot be found in the collection. Note that key should match the name attribute of the desired `HTTP::Cookie`.

def each(& : Cookie -> ) #

Yields each `HTTP::Cookie` in the collection.

def each : Iterator(Cookie) #

Returns an iterator over the cookies of this collection.

def empty? : Bool #

Whether the collection contains any cookies.

def fill_from_client_headers(headers : HTTP::Headers) : self #

Filling cookies by parsing the `Cookie` headers in the given `HTTP::Headers`.

def fill_from_headers(headers) #

Filling cookies by parsing the `Cookie` and `Set-Cookie` headers in the given `HTTP::Headers`.

DEPRECATED Use `#fill_from_client_headers` or `#fill_from_server_headers` instead.

def fill_from_server_headers(headers : HTTP::Headers) : self #

Filling cookies by parsing the `Set-Cookie` headers in the given `HTTP::Headers`.

def has_key?(key : String) : Bool #

Returns `true` if a cookie with the given key exists.

    request.cookies.has_key?("foo") # => true

def hash(hasher) #
Description copied from class Reference

See `Object#hash(hasher)`

def inspect(io : IO) #

Returns a string representation of this cookies list.

It uses the `Set-Cookie` serialization from `Cookie#to_set_cookie_header` which represents the full state of the cookie.

    HTTP::Cookies{
      HTTP::Cookie.new("foo", "bar"),
      HTTP::Cookie.new("foo", "bar", domain: "example.com"),
    }.to_s # => "HTTP::Cookies{\"foo=bar\", \"foo=bar; domain=example.com\"}"

def pretty_print(pp) : Nil #

Returns a string representation of this cookies list.

It uses the `Set-Cookie` serialization from `Cookie#to_set_cookie_header` which represents the full state of the cookie.

    HTTP::Cookies{
      HTTP::Cookie.new("foo", "bar"),
      HTTP::Cookie.new("foo", "bar", domain: "example.com"),
    }.to_s # => "HTTP::Cookies{\"foo=bar\", \"foo=bar; domain=example.com\"}"

def size : Int32 #

Returns the number of cookies contained in this collection.

def to_h : Hash(String, Cookie) #

Returns this collection as a plain `Hash`.

def to_s(io : IO) #

Returns a string representation of this cookies list.

It uses the `Set-Cookie` serialization from `Cookie#to_set_cookie_header` which represents the full state of the cookie.

    HTTP::Cookies{
      HTTP::Cookie.new("foo", "bar"),
      HTTP::Cookie.new("foo", "bar", domain: "example.com"),
    }.to_s # => "HTTP::Cookies{\"foo=bar\", \"foo=bar; domain=example.com\"}"